#!/usr/bin/php -q
<?php
//This is a wrapper to install access to Webalizer for each user on the server
// without them having to log on
// It creates a custom awstats.php for that specific user in their public_html dir
// Written by John Wilson June 2014
// Version 1.0

// Set up our variables to be usable by PHP
$opts = array();
$argv0 = array_shift($argv);

while(count($argv)) {
    $key = array_shift($argv);
    $value = array_shift($argv);
    $opts[$key] = $value;
}
$error=false;
// now we need to create the file to allow access to the Awstats
$username=$opts['user'];
$password=$opts['pass'];
$homeDir=$opts['homedir'];
$domain=$opts['domain'];

$outputName=$homeDir . "/public_html/awstats.php"; // the filename to write. Currently /public_html/awstats.php
$filenameToRead="/usr/local/cpanel/scripts/master_awstats.tmpl"; // the master filename, needs to be accessible by the calling script's user


// some basic error checking
if ($username == ''){
	echo "Error, the username was empty<BR>\n";
	$error=true;
}

if ($password == ''){
	$error=true;
	echo "Error, the password was empty<BR>\n";
}
if ($domain == ''){
	$error=true;
	echo "Error, the domain was empty<BR>\n";
}
if ($homeDir == ''){
	$error=true;
	echo "Error, the users home directory was not set\n";
}
function createAWSTATS($username,$password,$domain){
	// this'll be the start of the file
	$fileStart="<?php\n\$user='" . $username . "';\n\$pass='" . $password . "';\n\$domain='" . $domain . "';\n// Modified by John Wilson\n\n?>\n";
	//echo $fileStart . "<BR>";

	// let's read the master template file
	$fileToRead=fopen($filenameToRead, "r") or die ("\nUnable to open master_awstats.php");
	$dataRead = fread($fileToRead,filesize($filenameToRead));
	fclose($fileToRead);
//	echo $dataRead . "<BR>";
	// add the user details to the read template
	$dataToWrite = $fileStart . $dataRead;
//	echo $dataToWrite;

	// write the output file
	$fileToWrite=fopen($outputName, "w") or die ("\nUnable to open awstats.php for writing");
	echo "\nWriting file " . $outputName;
	fwrite($fileToWrite, $dataToWrite);
	fclose($fileToWrite);
	// now we need to change the owner of the file
	// as it's currently created by root

	$result=chown($outputName, $username);
	echo "\nOwnership change result = " . $result;

	//now let's change the group

	$result=chgrp($outputName, $username);
	echo "\nGroup change result = " . $result;

}
if ($error == false){ // if there are no errors then we can attempt to create the awstats.php
	createAWSTATS($username,$password,$domain); //call the function	
	
}
?>